' Liste.vbs

option explicit

Dim TCApp ' the TurboCAD application -- must be running for this script to work'
Dim TCDraw 'the active drawing - must be an open drawing for this script to work
Dim TCSel ' the current selection. If nothing is selected the script will exit
Dim TCGrf ' used to cycle through each selected graphic'

Dim VertFile ' file used to store the results
Dim FilePath ' path to output file. Normally the same folder as open drawing.
Dim FSO ' FileSystemObject for access to file operations
Dim i ' counter for each selected graphic

Sub Main
On Error Resume Next

' hook up to the running instance of TurboCAD
Set TCApp = GetObject("", "TurboCAD.Application")
If Err.Number <> 0 Then
   MsgBox "Zugriff auf TCAD nicht mglich" & Hex(Err.Number) & ": " _
   & Err.DescriptionErr.Clear
   Exit Sub
End If

' get the active drawing
Set TCDraw = TCApp.ActiveDrawing
If Err.Number <> 0 Then
   MsgBox "Keine geffnete Zeichnung.Script wird beendet."
   Err.Clear
   Exit Sub
End If

' get the current selection. If empty, complain and exit.
Set TCSel = TCDraw.Selection
If TCSel.Count < 1 Then
    MsgBox "Keine Auswahl.Script wird beendet."
    Exit Sub
End If

' start up the FileSystemObject for access to file operations.
Set FSO = CreateObject("Scripting.FileSystemObject")
' determine the path for the output file
FilePath = TCDraw.Path(0)
    If Len(FilePath) = 0 Then 'file hasn't been saved, so it has no path yet. 
                          'Use the program folder in this case.
           FilePath = TCApp.Path(0)
    Else
Dim endpath ' strip the drawing filename off of the drawing's path, and 
            ' append the output filename"'
endpath = InStrRev(FilePath, "\")
FilePath = Left(FilePath, endpath)
End If

' open the output file for text operations
Set VertFile = FSO.CreateTextFile(FilePath & "Liste.csv")
VertFile.WriteLine Filepath &  "Liste.csv"   & "   "   & date 

VertFile.writeline

'process each of the selected objects, and print its vertices to the file


Dim Teil

For i = 0 to TCSel.Count - 1

   Set TCGrf = TCSel.Item(i)
  
   Teil = TCGrf.Name
 
  
   VertFile.WriteLine (i+1) & ";" &  Teil  
Next

'Close the output file'
VertFile.Close
MsgBox "File saved to: " & FilePath & "Liste.csv"
'cleanup objects
TCVert = Nothing

TCGrf = Nothing
TCSel = Nothing
TCDraw = Nothing
TCApp = Nothing
End Sub
Main

